package java.lang.reflect;

import sun.reflect.ConstructorAccessor;
import sun.reflect.MethodAccessor;
import sun.reflect.LangReflectAccess;

class ReflectAccess implements LangReflectAccess
{
    ReflectAccess() {
    }
    
    public Field newField(Class<?> clazz, String s, Class<?> clazz2, int n, int n2, String s2, byte[] array) {
        return new Field(clazz, s, clazz2, n, n2, s2, array);
    }
    
    public Method newMethod(Class<?> clazz, String s, Class<?>[] array, Class<?> clazz2, Class<?>[] array2, int n, int n2, String s2, byte[] array3, byte[] array4, byte[] array5) {
        return new Method(clazz, s, array, clazz2, array2, n, n2, s2, array3, array4, array5);
    }
    
    public <T> Constructor<T> newConstructor(Class<T> clazz, Class<?>[] array, Class<?>[] array2, int n, int n2, String s, byte[] array3, byte[] array4) {
        return new Constructor(clazz, array, array2, n, n2, s, array3, array4);
    }
    
    public MethodAccessor getMethodAccessor(Method method) {
        return method.getMethodAccessor();
    }
    
    public void setMethodAccessor(Method method, MethodAccessor methodAccessor) {
        method.setMethodAccessor(methodAccessor);
    }
    
    public ConstructorAccessor getConstructorAccessor(Constructor<?> constructor) {
        return constructor.getConstructorAccessor();
    }
    
    public void setConstructorAccessor(Constructor<?> constructor, ConstructorAccessor constructorAccessor) {
        constructor.setConstructorAccessor(constructorAccessor);
    }
    
    public int getConstructorSlot(Constructor<?> constructor) {
        return constructor.getSlot();
    }
    
    public String getConstructorSignature(Constructor<?> constructor) {
        return constructor.getSignature();
    }
    
    public byte[] getConstructorAnnotations(Constructor<?> constructor) {
        return constructor.getRawAnnotations();
    }
    
    public byte[] getConstructorParameterAnnotations(Constructor<?> constructor) {
        return constructor.getRawParameterAnnotations();
    }
    
    public byte[] getExecutableTypeAnnotationBytes(Executable executable) {
        return executable.getTypeAnnotationBytes();
    }
    
    public Method copyMethod(Method method) {
        return method.copy();
    }
    
    public Field copyField(Field field) {
        return field.copy();
    }
    
    public <T> Constructor<T> copyConstructor(Constructor<T> constructor) {
        return constructor.copy();
    }
}
